#include  <stdio.h>
#include <math.h>

#define DEBUG
#undef DEBUG
#define MAX 105

#define sqr(a) ((a)*(a))
#define abs(a) (((a)<0)?-(a):(a))

int del(int R1, int I1, int R2, int I2, int test,
	int &pod_r, int &pod_i)
{  // vraci 1 pro chybu
	int zaklad;
	zaklad = sqr(I2)+sqr(R2);
	pod_r = ((R1-test)*R2 + I2*I1);
	pod_i =(I1*R2 - I2*(R1-test));
#ifdef bigDEBUG
	printf("%i+%ii -%i / %i+%ii = %i+%ii / zaklad %i\n", 
			R1, I1, test, R2, I2, pod_r, pod_i, zaklad); 
#endif
	if ((pod_r % zaklad) || (pod_i % zaklad)) return 0;
	pod_r /= zaklad; pod_i /= zaklad;
	return 1;
}

struct Zalozka {
	int Xr, Xi, count, Vystup;
} Zalozky[4096];
int numZalozky = 0;

void Res()
{
	int Xr, Xi;
	int Br, Bi, limit;
	int Vystup[MAX];
	int  count = 0;
	scanf("%i%i%i%i", &Xr, &Xi, &Br, &Bi);
	limit = (int) ceil(sqrt(sqr(Br) + sqr(Bi)));
	while (1) {
		if ((!Xi) && (Xr < limit)) {
			Vystup[count++] = Xr;
			break;
		}
		for (int i = 0; i < limit; i++) {
			int pod_r, pod_i;
			if (del(Xr, Xi, Br, Bi, i, pod_r, pod_i)) {
				struct Zalozka *u;
				u = Zalozky+(numZalozky++);
				u->Xr = pod_r; u->Xi = pod_i;
				u->count = count+1;
				u->Vystup = i;
#ifdef DEBUG
				printf("SAVED@%i (%i,%ii) - FOUND %i\n", count, pod_r, pod_i, i);
#endif				
			}
		}
		if (numZalozky) {
			struct Zalozka *u;
			u = Zalozky+numZalozky-1;
			Xr = u->Xr;
			Xi = u->Xi;
			count = u->count;
			Vystup[count-1] = u->Vystup;
#ifdef DEBUG			
			printf("LOADED (%i, %ii)\n", Xr, Xi);
#endif				
			numZalozky--;
		} else {
			puts("The code cannot be decrypted.");
			return;
		}
	}
	for (int i = count-1; i>=0; i--) {
		printf("%i", Vystup[i]);
		if (i) putchar(',');
	}
	putchar('\n');
}

int main()
{
	int N;
	scanf("%i", &N);
	while (N) {
		Res();
		N--;
	}
	return 0;
}
